# Accepting strings of the form (a^n)(b^n)(c^n), n >= 0, and nothing else,
# for example: abc, aabbcc, aaabbbccc, ...
# In every pass, an "a", a "b" and a "c" are overwritten by "X". In the end,
# the only symbol on the tape has to be "X".
#
# Initial tape content:

a a a b b b c c c

(0 _ fail r) (0 a continue r) (continue a 1 l) (continue b 1 l)

# search for an "a"
(1 a 2 X r)  (1 X r) (1 _ done l)
# search for next "b"
(2 a r) (2 X r) (2 b 3 X r)
# search for next "c"
(3 b r) (3 X r) (3 c rewind X l)

(rewind X l) (rewind c l) (rewind b l) (rewind a l)
(rewind _ 1 r)

# blank out the tape in the end (not necessary)
(done X done _ l) (done _ quit l)

[0] {quit}
