# This program adds two binary numbers.
# Contributed by Christoph Bonitz.

# Initial tape content:
1 1 0 1 1 0 + 1 1 1 1 0 0

# In each step, the last bit of the right addend is deleted.
# In the left addend, the current position is marked by replacing the
# rightmost digit with a letter: Z for 0 (zero) and N (like oNe) for 1.
#
# For example, after three cycles
# 110110+111100
# becomes
# 111ZNZ+111
#
# In the end, the calculation looks like 1NNZZNZ+.
# At this point, the plus sign is removed and the letters are replaced by
# numbers. So we get 1110010.


# Skip left addend
(0 0 r) (0 1 r) (0 N r) (0 Z r) (0 _ 9 r)
# Skip +
(0 + 1 r)
# Skip right addend
(1 0 r) (1 1 r)
# Jump left when hitting blank
(1 _ 2 l)


# if "LSB" == 0 go to state 3
(2 0 3 _ l)

# else if  "LSB" == 1 go to state 5
(2 1 5 _ l)


# If last symbol is +, right addend has been completely added.
# Remove +, go left and switch to state 8
(2 + 8 _ l)

# State 3: skip 1 or 0 until hitting +, then go to state 4
(3 0 l) (3 1 l) (3 + 4 l)

# State 4: Skip Z (ero) and N (one)
(4 Z l) (4 N l)
# Until hitting current position in left addend,
# replace number with letter to mark position
(4 0 0 Z r) (4 1 0 N r) (4 _ 0 Z r)

# State 5: "LSB" of right addend was 1
# skip 1 or 0 until hitting +, then go to state 6
(5 0 l) (5 1 l) (5 + 6 l)

# State 6: Skip Z (zero) and N (one)
(6 Z l) (6 N l)

# If current position is 0, replace with N
# (instead of 1) and continue with State 0

(6 0 0 N r) (6 _ 0 N r)

# If current position is 1 replace with Z
# (instead of 0) and go left

(6 1 7 Z l)

# then turn 1 into 0
(7 1 7 0 l)

# until hitting 0 or a blank (which is replaced with N)
# go to 0

(7 0 0 1 r) (7 _ 0 1 r)


# State 8: Replace letters with numbers
(8 Z 8 0 l) (8 N 8 1 l)

# .. until hitting blank or a number

(8 0 l) (8 1 l) (8 _ 9 r)


[0] {9}
