# Input: A / B (A, B: two numbers in unary encoding)
# Output: 1 if B divides A, 0 otherwise.
#
# initial tape content:

1 1 1 1 1 1 / 1 1 1

[start]

# 0 is divisible by any number
(start / yes _ r)

(start 1 findB r)

# strategy: copy B over A again and again, starting left 1s in A are replaced
# by 0, the current position in B is marked by "a".

(findB 1 r) (findB / found r)
(found _ error r)

(found 1 findendB r)
(findendB 1 r)
(findendB _ markB l)
(markB 1 writeonce a l) (writeonce 1 l)
(writeonce / markA l)

(markA 0 l)
(markA 1 goback 0 r)
(markA _ no r)

(goback 0 r) (goback / checkcopiedonce r)

(checkcopiedonce 1 notcopiedonce r)
(checkcopiedonce a checkdivisible l)

(checkdivisible / l) (checkdivisible 0 l) (checkdivisible _ yes r)

# not copied often enough - try more
(checkdivisible 1 needmore r) (needmore 0 r) (needmore / yescopiedonce / r)

(yescopiedonce 1 r) (yescopiedonce a yescopiedonce 1 r)
(yescopiedonce _ markB l)

(notcopiedonce 1 r) (notcopiedonce a markB l)

(yes 1 yes _ r) (yes / yes _ r) (yes a yes _ r) (yes 0 yes _ r)
(yes _ stop 1 r)

(no 1 no _ r) (no / no _ r) (no a no _ r) (no 0 no _ r)
(no _ stop 0 r)

(stop _ halt l)
{halt}
