# Input: A, a number in unary encoding
# Output: 1 if A is prime, 0 otherwise.
#
# initial tape content:

1 1 1 1 1 1 1

# This is in principle an extension to the divisibility test.
# Very inefficient (should try 2, 3, 5, 7, 9, 11, 13, ...), but doing the job.
# We try divisibility of A by 2, 3, 4, 5, .... If we reach A without
# having found a number by which A is divisible, then A must be prime.

[start]

# special cases: 0, 1, 2
(start _ no r)
(start 1 atleast_one r)
(atleast_one _ no l)
(atleast_one 1 atleast_two r)
(atleast_two 1 atleast_three r)
(atleast_two _ two l)
(two 1 two _ l)
(two _ yes r)

(atleast_three 1 r)
# begin of divisibility test - start with B = 2
# separate dividend A from divisor B by "," (comma)
(atleast_three _ start_test0 , r)
(start_test0 _ start_test1 1 r)
(start_test1 _ start_test2 1 r)
(start_test2 _ markB l)

(trynextfactor 0 trynextfactor 1 r)
(trynextfactor , r)
(trynextfactor 1 r)
(trynextfactor a trynextfactor 1 r)
(trynextfactor _ checkequality 1 r)
(checkequality _ l)

# See if B == A. If yes, then A is prime.
(checkequality 1 skipB X l)
(skipB 1 l)
(skipB , findequivalent l)
(findequivalent Y l)
(findequivalent 1 nextdigit Y r)
(nextdigit Y r) (nextdigit , r) (nextdigit 1 r) (nextdigit X checkequality l)

(checkequality , checkonlyY l)
(checkonlyY Y l)
(checkonlyY _ yesprime r)

(yesprime Y yesprime _ r)
(yesprime , yesprime _ r)
(yesprime X yesprime _ r)
(yesprime _ yes r)

(checkonlyY 1 it_is_less r)
(it_is_less Y it_is_less 1 r)
(it_is_less , r)
(it_is_less X it_is_less 1 r)
(it_is_less _ markB l)


# strategy: copy B over A again and again, starting left 1s in A are replaced
# by 0, the current position in B is marked by "a".

(markB 1 writeonce a l) (writeonce 1 l)
(writeonce , markA l)

(markA 0 l)
(markA 1 goback 0 r)
(markA _ trynextfactor r)

(goback 0 r) (goback , checkcopiedonce r)

(checkcopiedonce 1 notcopiedonce r)
(checkcopiedonce a checkdivisible l)

(checkdivisible , l) (checkdivisible 0 l)
# when we reach _ here, it means that B divides A, so A cannot be prime
(checkdivisible _ no r)

# not copied often enough - try more
(checkdivisible 1 needmore r) (needmore 0 r) (needmore , yescopiedonce , r)

(yescopiedonce 1 r) (yescopiedonce a yescopiedonce 1 r)
(yescopiedonce _ markB l)

(notcopiedonce 1 r) (notcopiedonce a markB l)

(yes 1 yes _ r) (yes , yes _ r) (yes a yes _ r) (yes 0 yes _ r)
(yes _ stop 1 r)

(no 1 no _ r) (no , no _ r) (no a no _ r) (no 0 no _ r)
(no _ stop 0 r)

(stop _ halt l)
{halt}
